%global oname CodeNarc
Name:          codenarc
Version:       0.17
Release:       11%{?dist}
Summary:       Groovy library that provides static analysis features for Groovy code
License:       ASL 2.0
Url:           http://codenarc.sourceforge.net/
Source0:       http://downloads.sourceforge.net/project/codenarc/codenarc/CodeNarc%20Version%20%{version}/CodeNarc-%{version}-bin.tar.gz
# use antrun-plugin instead of gmaven
# fix log4j version
Patch0:        codenarc-0.17-antrunplugin.patch
# remove @Override
# unavailable method in groovy 1.8.x (...)
Patch1:        codenarc-0.17-groovy18.patch

BuildRequires: maven-local
BuildRequires: maven-antrun-plugin
BuildRequires: mvn(org.sonatype.oss:oss-parent:pom:)

# groovy-all embedded libraries
BuildRequires: mvn(antlr:antlr)
#BuildRequires: mvn(org.ow2.asm:asm-all)
# -distroshaded
BuildRequires: objectweb-asm3
BuildRequires: mvn(commons-cli:commons-cli)
BuildRequires: mvn(org.slf4j:slf4j-nop)

BuildRequires: mvn(junit:junit)
BuildRequires: mvn(log4j:log4j:1.2.17)
BuildRequires: mvn(net.sourceforge.cobertura:cobertura)
BuildRequires: mvn(org.apache.ant:ant)
BuildRequires: mvn(org.apache.ant:ant-junit)
#BuildRequires: mvn(org.codehaus.groovy:groovy-all)
BuildRequires: mvn(org.codehaus.groovy:groovy:1.8.9)
BuildRequires: mvn(org.gmetrics:GMetrics)

BuildArch:     noarch

%description
CodeNarc is a static analysis tool for Groovy source code,
enabling monitoring and enforcement of many coding standards
and best practices. CodeNarc applies a set of Rules
(predefined and/or custom) that are applied to each Groovy
file, and generates an HTML report of the results, including
a list of rules violated for each source file, and a count
of the number of violations per package and for the whole
project.

%package javadoc
Summary:       Javadoc for %{name}

%description javadoc
This package contains javadoc for %{name}.

%prep
%setup -q -n %{oname}-%{version}

find . -name "*.jar" -delete
find . -name "*.class" -delete
rm -rf docs/*

%patch0 -p0
%patch1 -p1

sed -i 's#groupId>org.ow2.asm#groupId>asm#' pom.xml
sed -i 's#version>4.0#version>3#' pom.xml
sed -i 's#artifactId>groovy-all#artifactId>groovy#' pom.xml
sed -i 's#version>1.8.9#version>1.8#' pom.xml

%pom_remove_plugin :maven-javadoc-plugin

chmod 644 README.txt
for d in CHANGELOG.txt LICENSE.txt NOTICE.txt README.txt ; do
  sed -i 's/\r//' $d
done

%mvn_file org.%{name}:%{oname} %{name} %{oname}

%build

%mvn_build

%install
%mvn_install

%files -f .mfiles
%doc CHANGELOG.txt README.txt
%license LICENSE.txt NOTICE.txt

%files javadoc -f .mfiles-javadoc
%license LICENSE.txt NOTICE.txt

%changelog
* Fri Jan 30 2015 gil cattaneo <puntogil@libero.it> 0.17-11
- re-base for use groovy 2

* Fri Jan 30 2015 gil cattaneo <puntogil@libero.it> 0.17-10
- introduce license macro

* Thu Nov 13 2014 gil cattaneo <puntogil@libero.it> 0.17-9
- fix log4j12 classpath/version
- remove (g)maven references

* Thu Nov 13 2014 Mikolaj Izdebski <mizdebsk@redhat.com> - 0.17-8
- Remove POM patch changing artifactId from groovy-all to groovy

* Sat Jun 07 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.17-7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Fri Mar 28 2014 Michael Simacek <msimacek@redhat.com> - 0.17-6
- Use Requires: java-headless rebuild (#1067528)

* Thu Nov 14 2013 gil cattaneo <puntogil@libero.it> 0.17-5
- use objectweb-asm3

* Sat Aug 03 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.17-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Wed Feb 13 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.17-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_19_Mass_Rebuild

* Mon Aug 06 2012 gil cattaneo <puntogil@libero.it> 0.17-2
- fixed the permissions and encoding issues on *.txt files
- change with_gmaven to 0 (only for now)
- generate javadocs with ant support

* Thu Mar 29 2012 gil cattaneo <puntogil@libero.it> 0.17-1
- initial rpm
